﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using FlexGridDemo.Models;
using System.Data.Entity;
using FlexGridDemo.Extensions;
using System.Data;

namespace FlexGridDemo.Controllers
{
    public class HomeController : Controller
    {
        private readonly GridDbContext db = new GridDbContext();
        public ActionResult Index()
        {
            return View();
        }
        //两种获取参数的方式，一种在action上面直接接收，另一种就是用Request.Form()或者Formcollection来接收
        public JsonResult FlexigridList(int page,int rp,string qtype,string query,string sortname,string sortorder)
        {
            //获取表格控件需要的参数
            //int page = int.Parse(Request.Form["page"]);
            //int rp = int.Parse(Request.Form["rp"]);
            //string qtype = Request.Form["qtype"].ToString();
            //string query = Request.Form["query"].ToString();
            //string sortname = Request.Form["sortname"].ToString();
            //string sortorder = Request.Form["sortorder"].ToString();

            //var q = db.Students.ToList().AsQueryable();
            var q = from c in db.Students
                    select c;
            ////根据某一字段进行模糊查询，见扩展方法
            if (!string.IsNullOrEmpty(qtype) && !string.IsNullOrEmpty(query))
            {
                q = q.Like(qtype, query);
            }            
            ////按某一字段进行排序
            if (!string.IsNullOrEmpty(sortname) && !string.IsNullOrEmpty(sortorder))
            {
                q = q.OrderBy(sortname, (sortorder == "asc"));
            }
            ////分页
            q = q.Skip((page - 1) * rp).Take(rp);
            ////构造前台需要的JSON数据类型
            List<Object> row=new List<Object>();
            foreach (Student stu in q)
            {
                var cells = new List<string>() {stu.ID.ToString(), stu.Name, stu.Age.ToString(), stu.Address, stu.Mobile, stu.QQ, stu.Description };
                row.Add(new { id = stu.ID, cell =cells });
            }
            return Json(new { page=page,total=db.Students.Count(),rows=row}, JsonRequestBehavior.AllowGet);
        }
        //添加及修改
        public ActionResult AddStudent(int id=0)
        {
            var stu=id>0?db.Students.Find(id):new Student();
            return View(stu);
        }
        [HttpPost]
        public ActionResult AddStudent(Student student,FormCollection fc)
        {
            TryUpdateModel(student, fc);
            if (student.ID == 0)
                db.Students.Add(student);
            else
                db.Entry(student).State = EntityState.Modified;
            db.SaveChanges();
            return RedirectToAction("Index");
        }
        //批量删除
        public ActionResult DelStudent(string ids)
        {
            var idarray = ids.Split(',');
            foreach(var id in idarray)
            {
                var temp=db.Students.Find(int.Parse(id));
                db.Entry(temp).State=EntityState.Deleted;
            }
            db.SaveChanges();
            return Json(true);
        }
    }
}
